/*
 * upeek version 3.0
 * 
 * copyright @2015 tienquang
 * 
 */

jwplayer.key = 'l33PiUta/XdDcW+Etg4rUPibBw1qZApFA2EFFjZwgHw=';


$.mobile.orientationChangeEnabled = true;
$.urlParam = function (name) {
    var results = new RegExp('[\?&]' + name.toLowerCase() + '=([^&#]*)').exec(window.location.href);
    if (results == null) {
        return null;
    } else {
        return results[1] || 0;
    }
}

function getParamValue(paramName) {
    if (paramName === undefined || paramName === '')
        return '';

    var query = window.location.search.trim().replace('?', '');
    if (query === '')
        return '';

    var arr = query.split('&');

    if (arr === undefined || arr === null || arr.length === 0)
        return '';

    for (var i = 0; i < arr.length; i++) {
        var param = arr[i].split('=');

        if (param[0].toLowerCase() === paramName.toLowerCase())
            return param[1];
    }

    return '';
}

function Current() {
    this.IsMobile = false;    
    this.IsFirstPlay = true;
    this.Session = null;
    this.IsLoaded = false;
    this.CurrentWidth = 0;
    this.CurrentHeight = 0;
    this.IsStopped = false;
    this.UpdateId = -1;
    this.PingId = -1;
    this.IsSafari = false;
    this.Feed = null;
    this.Replaying = false;
    this.Playing = false;
    this.PlayFirst = true;
    this.Trick = -1;
	this.IsFullscreen = false;
    this.IsLandscapeView = false;
}

function Stream(id) {
    this.StreamId = id;
    this.PublishId = -1;
    this.TotalLike = 0;
    this.TotalPlay = 0;
    this.CurrentPlay = 0;
    this.TotalShare = 0;    
    this.CanReplay = false;
    this.IsLandscape = false;
    this.StreamH = '';
    this.StreamR = '';
    this.ReplayR = '';
    this.ReplayH = '';
}

function updateUser(user, avatar) {
    var $user = $('.info-user');

    $user.children('div').first().children('img').prop('src', avatar);
    $user.children('div').last().text(user);
}

function updateDetail(title, location, category) {
    var $detail = $('.info-detail');

    $detail.children('.detail-title').text(title);
    $detail.children('.detail-location').text(location);
    $detail.children('.detail-category').text(category);
}

function updateCount(share, like, view, totalView) {
    var $count = $('.info-count');

    (isNaN(share)) && (share = 0);
    (isNaN(like)) && (like = 0);
    (isNaN(view) || view === 0) && (view = 1);

    $count.children('.count-share').find('span').text(share);
    $count.children('.count-like').find('span').text(like);
    $count.children('.count-view').find('span').text(view);
}

function stop() {
	   
    jwplayer().stop();

    current.IsStopped = true;
    current.IsFirstPlay = false;

    togglePlay(false);
    togglePlayMobile(false);
    
    updateCount(stream.TotalShare, stream.TotalLike, stream.TotalPlay);

    (current.UpdateId > 0) && clearInterval(current.UpdateId);
    (current.PingId > 0) && clearInterval(current.PingId);

    $('.overlay-over').removeClass('hidden');
}

function loadStreamData(streamId) {
    var url = api + '/publishing/getbyname?name=' + streamId;
    var req = $.ajax({ url: url, timeout: 15000 });
    

    req.fail(function (jqXHR, status, error) {		
        $('.btn-play').html('Error Occrurred');
    });

    req.done(function (response, status, jqXHR) {
        var data = response.Data;

        if ($.isEmptyObject(data)) {

            stop();

            return;
        }

        stream.PublishId = data.PublishID;
        stream.TotalLike = data.TotalLike;
        stream.TotalShare = data.TotalShare;
        stream.TotalPlay = data.TotalView;
        stream.CurrentPlay = data.CurrentPlay;
        stream.IsLandscape = !data.IsVideoPortrait;
        stream.CanReplay = data.IsPublicShare;


        $('.overlay').css({ 'background-image': 'url(' + data.StreamFullImageUrl + ')' });

        if (stream.IsLandscape) {
            $('.wrapper').addClass('landscape');
			            
            current.CurrentWidth = (window.innerWidth > 0) ? window.innerWidth : screen.width;
            current.CurrentHeight = (current.CurrentWidth * 9 / 16);

            var portrait = window.orientation === 0 ? true : false;
            var main = $('.main');
            var overlay = $('.overlay-button');

            if (portrait) {
                main.css({ 'height': current.CurrentHeight + 'px' });

                if (current.CurrentHeight < 250) {
                    overlay.addClass('tiny');
                } else {
                    overlay.removeClass('tiny');
                }
                
                current.IsLandscapeView = false;
            } else {
                main.css({ 'height': '105vh' });

                current.CurrentWidth = (window.innerWidth > 0) ? window.innerWidth : screen.width;
                current.CurrentHeight = (current.CurrentWidth * 9 / 16);
                
                current.IsLandscapeView = true;
            }

        }

        
        current.Feed = {
            method: 'feed',
            display: 'popup',
            link: data.Link,
            caption: data.Category,
            picture: data.StreamFullImageUrl,
            description: data.Title,
            name: stream.Username
        };

        var fbShare = 'http://www.facebook.com/sharer.php?u=' + data.Link;
        var twShare = 'http://twitter.com/share?url=' + encodeURI(data.Link) + '&text=' + data.Title;
        var gpShare = 'https://plus.google.com/share?url=' + data.Link;
        var emShare = 'mailto:?subject=Watch%live%on%uPeek?body=' + data.Link;

        $('.share-facebook').prop('href', fbShare);
        $('.share-twitter').prop('href', twShare);
        $('.share-gplus').prop('href', gpShare);
        $('.share-email').prop('href', emShare);

        updateUser(data.Username, data.ProfileImage);
        updateDetail(data.Title, data.LocationName, data.Category);
        updateCount(data.TotalShare, data.TotalLike, data.CurrentPlay, data.TotalPlay);
    });

    return req;
}

function togglePlay(play) {
    
    var overlay = $('.overlay');
    var main = $('.main');
    var buttonPlay = $('.btn-play');
    var info = $('.info');
    
    if (play) {
        overlay.fadeOut();
        main.addClass('playing');
        buttonPlay.attr('disabled', 'disabled');
        info.removeClass('touched');
    } else {
        overlay.fadeIn();
        main.removeClass('playing');
        buttonPlay.removeAttr('disabled');       
    }
    
    buttonPlay.html('start watching');        
    (stream.CanReplay && current.Replaying) && (buttonPlay.html('watch replay'));
}

function togglePlayMobile(play) {
    var buttonPlay = $('.btn-play');
    
    if (play) {
        buttonPlay.removeAttr('disabled');        
    } else {        
        buttonPlay.attr('disabled', 'disabled');       
    }
}

function streamOver(replay) {
    
    (replay === undefined || replay === null) && (replay = true);

    if (current.IsStopped) {       
        return;
    }
    
    if (replay && current.IsFirstPlay) {
    	if (stream.CanReplay) {
    		
    		togglePlayMobile(true);
			    		
    		current.PlayFirst = false;
    		current.Replaying = true;

    		if (!current.IsLoaded) {
    			current.IsLoaded = true;
    			$('.btn-play').html('watch replay');
    			    			
    			jwplayer().load({
    				sources: [{ file: stream.ReplayR }, { file: stream.ReplayH }]
    			});
                
    		}    		

    		return;
    	}
    }
    
    current.Playing = false;
    current.IsStopped = true;
    current.Replaying = false;
    
    stop();
}

function replayStream() {
    
}

function updateData() {
    if (current.IsStopped) {
        
        stop();
        
        return;
    }
    
    var url = api + '/publishing/getbyid?id=' + stream.PublishId;
    var req = $.ajax({url: url, timeout: 5000});
    
    req.fail(function(jqXHR, status, error){
      
    });
    
    req.done(function (response, status, jqXHR) {
		
        if ($.isEmptyObject(response) || $.isEmptyObject(response.Data)) {            
            return;
        }
        
        var data = response.Data;
        
        (data.TotalPlay > 0) && (stream.TotalPlay = data.TotalPlay);
        (data.TotalLike > 0) && (stream.TotalLike = data.TotalLike);
        (data.TotalShare > 0) && (stream.TotalShare = data.TotalShare);
        
        (!current.IsFirstPlay) && (stream.CanReplay = data.IsPublicShare);
		        
        stream.CurrentPlay = data.CurrentPlay;
        
        updateCount(stream.TotalShare, stream.TotalLike, stream.CurrentPlay);

        if (data.Status.toLowerCase() === 'stopped') {
        	streamOver(true);
        } else {
            current.IsFirstPlay = false;
            if (current.IsMobile) {               
                $('.btn-play').html('start watching');
            }
        }        
    });
}

function updatePing() {
    current.Session = window.sessionStorage;
    
    if (current.Session === undefined || typeof current.Session !== 'object') {        
        return;
    }

    if (current.Session.anonymous === undefined) {
        if (stream.PublishId === -1) {
            return;
        }

        var req = $.ajax({
            url: api + '/webview/add',
            data: {
                ID: 0, StreamID: stream.PublishId
            },
            method: 'post'
        });

        req.fail(function (jqXHR, status, error) {
            
        });

        req.done(function (response, status, jqXHR) {

            var id = parseInt(response.Data);

            if (isNaN(id) || id < 0) {
                return;
            }

            var anonymous = { id: id };
            current.Session.anonymous = JSON.stringify(anonymous);
			
            updateData();
        });
       
        return;
    }

    var anonymous = JSON.parse(current.Session.anonymous);
   
    var pingReq = $.ajax({
        url: api + '/webview/lastalive?id=' + anonymous.id,
        timeout: 30000
    });

    pingReq.done(function (resp) {
        
    });
}

function toggleFullscreen() {
	var fullscreenEnabled = document.fullscreenEnabled || document.mozFullScreenEnabled || document.webkitFullscreenEnabled;

	current.IsFullscreen = !current.IsFullscreen;

	var wrapper = $('.wrapper');
	var player = $('.player').children('div').first();

	player.removeClass('jwfullscreen').css({ top: '50% !important' });


	if (current.IsFullscreen) {

		if (current.IsLandscapeView) {
			var width = (window.innerWidth > 0) ? window.innerWidth : screen.width;
			var height = width * 9 / 16;

			wrapper.addClass('fullscreen').css({ width: width + 'px', height: height + 'px', 'max-height': height + 'px' });
			//player.removeClass('player-valign').css({position:'', top: ''});
			player.css({ 'max-height': height + 'px' });

		} else {
			player.css({ 'max-height': 'none' });
		}
	} else {
		wrapper.removeClass('fullscreen').css({ width: '', height: '', 'max-height': '' });
	}

}

/*
 * variables
 * 
 */

var api = 'https://ws1.upeek.tv/api/v2';
var current;
var stream;
var player;


$(document).ready(function () {

    $('.wrapper').append('<div class="rotate-notify">Please rotate your device to view full size</div>');
    $('.btn-play').attr('disabled', 'disabled');
    //$('.player').children('div').css({ border: '1px solid #fff' });
	    
    current = new Current();
    
    current.IsSafari = Object.prototype.toString.call(window.HTMLElement).indexOf('Constructor') > 0;
    current.IsMobile = /Android|webOS|iPhone|iPad|iPod|BlackBerry|IEMobile|Opera Mini/i.test(navigator.userAgent);

    //var fullId = $.urlParam('streamid');
	var fullId = getParamValue('streamid');

    if (fullId === undefined || fullId === null || fullId === '') {        
        //fullId = '357aecab-8b1a-4fd1-a620-7779a5338a34'; // live
        //fullId = 'a319e808-89f9-4c5b-b968-88757ffe27ec'; // landscape
        return;
    }

    var idArr = fullId.split('_'), id = fullId;
    if (idArr.length > 1) {
        id = idArr[0];
    }

    stream = new Stream(id);

    if (current.IsSafari) {
        stream.StreamH = 'http://wl.upeek.tv:8081/rslive/' + id + '/playlist.m3u8';
        stream.StreamR = 'http://wl.upeek.tv:8081/rslive/' + id + '/playlist.m3u8';
        stream.ReplayH = 'http://la1.upeek.tv:1935/hist_upeek/mp4:' + fullId + '.mp4/playlist.m3u8';
        stream.ReplayR = 'http://la1.upeek.tv:1935/hist_upeek/mp4:' + fullId + '.mp4/playlist.m3u8';
    } else {
        stream.StreamH = 'http://wl.upeek.tv:8081/rslive/' + id + '/playlist.m3u8';
        stream.StreamR = 'rtmp://wl.upeek.tv:1935/rslive/' + id;
        stream.ReplayH = 'http://la1.upeek.tv:1935/hist_upeek/mp4:' + fullId + '.mp4/playlist.m3u8';
        stream.ReplayR = 'rtmp://la1.upeek.tv:1935/hist_upeek/flv:' + fullId;
    }



    jwplayer('jw-player').setup({
        playlist: [{
            sources: [{ file: stream.StreamR }, { file: stream.StreamH }]
        }],
        title: "Watch Live",
        primary: 'flash',
        width: '100%',
        height: '100%',
        stretching: 'fill',
        androidhls: true,
        wmode: 'transparent',
        controls: true,
        rtmp: { bufferlength: 7.5 },
        autostart: true
    });

    

    //
    // player
    //
    $.when(loadStreamData(id)).then(function (response, status, jqXHR) {
       
        jwplayer().onReady(function (e) {
			
            jwplayer().onPlaylist(function (e) {
               
                if (current.IsMobile && !current.RePlaying) {                   
                    togglePlayMobile(true);
                    return;
                }
            }).onPlay(function (e) {
				
				togglePlay(true);

            }).onPause(function (e) {				 
				togglePlay(false);

				$('.btn-play').removeClass('clicked');
            }).onIdle(function (e) {
				
            }).onComplete(function (e) {            	
            	streamOver(false);
            }).onError(function(e){
               
                togglePlay(false);
			}).onDisplayClick(function(){
                
            });

        });

        current.UpdateId = setInterval(updateData, 5000);
        current.PingId = setInterval(updatePing, 30000);
    });
    
    $(document).on('click touchstart', '.btn-play', function (e) {

        e.preventDefault();

        var self = $(this);
        var content = self.html();

       
        var loader = $("<div class='loader'> " +
                            "<div class='loader-inner line-scale'><div></div><div></div><div></div><div></div><div></div></div> " +
                        + "</div>");                       

        if (content.toLowerCase().indexOf('watch') < 0) {          
            return; // not ready yet
        }

        self.html('').append(loader);
        
        if (self.is('.clicked')) {          
            return; // prevent double click
        } else {          
            self.addClass('clicked');
        }

        self.attr('disabled', 'disabled');

        jwplayer().play();

        var t = setTimeout(function () {

            var state = jwplayer().getState();

            if (state === undefined || state === null) {
                clearTimeout(t);
                return;
            }

            if ($.inArray(state, ['BUFFERING', 'IDLE'])) {               
                jwplayer().play(true);
                togglePlay(true);
            }
            
            clearTimeout(t);
        }, 1000);
    });

    $(document).on('click touchstart', '.btn-share', function (e) {
        e.preventDefault();

        $(this).next().toggleClass('active');
    });

    $(document).on('click touchstart', '.share-facebook', function (e) {
        e.preventDefault();

        FB.ui(current.Feed, function () { });
    });

    $(document).on('click touchstart', '.overlay-over a', function (e) {
        e.preventDefault();
    });

    $(document).on('click touchstart', '.overlay-over .close', function (e) {
        e.preventDefault();

        $('.overlay-button').removeClass('hidden');
        $('.overlay-over').remove();
    });

    $('.player').on('touchstart', function (e) {    	        
    	$('.info').toggleClass('touched');
    });
    
    $('.main').mouseover(function () {
        ($(this).is('.playing')) && ($('.info').addClass('touched'));
    });

    $('.main').mouseleave(function () {
        ($(this).is('.playing')) && ($('.info').removeClass('touched'));
    });

    $(document).on('click touchstart', '.share', function (e) {
        e.preventDefault();

        var url = $(this).prop('href');
        if (url.indexOf('#') === (url.length - 1)) {
            return false;
        }

        var width = 500, height = 350;
        var top = screen.height / 2 - height / 2;
        var left = screen.width / 2 - width / 2;

        window.open(url, 'uPeek Share', 'top=' + top + ', left=' + left + ', width=' + width + ', height=' + height + ', toolbar=1, resizable=0');
    });

    $(window).on('orientationchange', function (e) {
        if (!stream.IsLandscape || $.isEmptyObject(e)) {
            return;
        }
       
        var ori = window.orientation,
        width = (ori == 90 || ori == -90) ? screen.height : screen.width;
                
        var main = $('.main');
        var overlay = $('.overlay-button');

        current.CurrentWidth = width;
        current.CurrentHeight = width * 9 / 16;

        var player = $('.player').children('div').first();

        if (e.orientation === 'portrait') {

            main.css({ 'height': current.CurrentHeight + 'px' });

            if (current.CurrentHeight < 250) {
                overlay.addClass('tiny');
            } else {
                overlay.removeClass('tiny');
            }

            current.IsLandscapeView = false;

        } else {
            main.css({ 'height': '105vh' });
            overlay.removeClass('tiny');
            current.IsLandscapeView = true;

            if (current.IsFullscreen) {
                player.removeClass('player-valign');
                
                var t = setTimeout(function () {
                	
                    if (current.IsFullscreen) {
                    	var width = (window.innerWidth > 0) ? window.innerWidth : screen.width;
                    	var height = width * 9 / 16;
                        console.log('(width, height) = (%s, %s)', width, height);

                        $('.wrapper').removeAttr('style').css({ height: height + 'px', 'max-height': height + 'px !important' });
                    }
                   
                }, 1000);

            }

            
        }

    });
	
    document.addEventListener("fullscreenchange", function (e) {
    	toggleFullscreen();
    });

    document.addEventListener("mozfullscreenchange", function (e) {
    	toggleFullscreen();
    });

    document.addEventListener("webkitfullscreenchange", function (e) {
    	toggleFullscreen();
    });

    document.addEventListener("msfullscreenchange", function (e) {
    	toggleFullscreen();
    });
});